#include "ball.h"

#include "global.h"

BALL::BALL()
{
    x = 0;
    y = SCREEN_H / 2;
    dx = 0;
    dy = -30;
}

BALL::BALL(int _x, int _y, int speed, fixed angle)
{
    dx = fixtoi(fixmul(itofix(speed), fixsin(angle)));
    dy = fixtoi(fixmul(itofix(speed), fixcos(angle)));
    x = _x;
    y = _y;

}

void BALL::logic()
{
    x += dx;
    y += dy;
    dy += .7;

    if (x < (MIN_PLAY_AREA + MAX_DIAMETRE))
    {
        dx = abs(dx);
    }

    if (x > (MAX_PLAY_AREA - MAX_DIAMETRE))
    {
        dx = -abs(dx);
    }

    if (y > (SCREEN_H + 10))
        kill();

}

#include "fat.h"
void BALL::render(BITMAP *buffer)
{
    circlefill(buffer, CENTRE(x), y, MAX_DIAMETRE, makecol(96,96,96));
    fat_circle(buffer, CENTRE(x), y, MAX_DIAMETRE, 1, makecol(255,0,0));
}

