//#define DEBUGMODE
#include <allegro.h>

#include "sling_shot.h"
#include "ball.h"

#include "global.h"
#include "fps/fps_head.inc"

volatile int logic_counter = 0;
void logic_counter_handler()
{
    logic_counter++;
}
END_OF_FUNCTION(logic_counter_handler)

#include "invader.h"

int circle_box(BITMAP *buffer,
				int x, int y, int r, int step,
				int t_x, int t_y, int b_x, int b_y
				)
{
	for (int a = 0; a < 256; a += step)
	{
		int b = a + step;
		int x1, y1, x2, y2;

		x1 = fixtoi(r * fixsin(itofix(a)));
		y1 = fixtoi(r * fixcos(itofix(a)));

		x2 = fixtoi(r * fixsin(itofix(b)));
		y2 = fixtoi(r * fixcos(itofix(b)));

		int w = b_x - t_x;
		int h = b_y - t_y;

		int __a[4], __b[4], __c[4], __d[4];

		__a[0] = t_x;     __b[0] = t_y;     __c[0] = t_x + w; __d[0] = t_y;
		__a[1] = t_x;     __b[1] = t_y + h; __c[1] = t_x + w; __d[1] = t_y + h;
		__a[2] = t_x;     __b[2] = t_y;     __c[2] = t_x;     __d[2] = t_y + h;
		__a[3] = t_x + w; __b[3] = t_y;     __c[3] = t_x + w; __d[3] = t_y + h;

		int __e = x + x1;
		int __f = y + y1;
		int __g = x + x2;
		int __h = y + y2;

		circle(buffer, CENTRE(x), y, r, makecol(0,0,255));

		for (int c = 0; c < 4; c++)
		{
			line(buffer, CENTRE(__a[c]), __b[c], CENTRE(__c[c]), __d[c], makecol(0,255,0));
			if (line_line_intersection(__a[c], __b[c], __c[c], __d[c], __e, __f, __g, __h) > 0)
			{
				line(buffer, CENTRE(__e), __f, CENTRE(__g), __h, makecol(255,0,0));
			}
			else
			{
//				line(buffer, CENTRE(__e), __f, CENTRE(__g), __h, makecol(0,0,255));
			}
		}
	}
	return 0;
}

int add_invader = 0;

void colide(INVADER &i, BALL &b)
{
    const int s = MAX_DIAMETRE;
    int b1 = b.x + MAX_DIAMETRE;
    int b2 = b.y + MAX_DIAMETRE;
    int b3 = b.x - MAX_DIAMETRE;
    int b4 = b.y - MAX_DIAMETRE;

    int t_x = i.x - 30;
    int t_y = i.y - 60;
    int b_x = i.x + 30;
    int b_y = i.y;

    int w = b_x - t_x;
    int h = b_y - t_y;

    int __a[4], __b[4], __c[4], __d[4];
    __a[0] = t_x;     __b[0] = t_y;     __c[0] = t_x + w; __d[0] = t_y;
    __a[1] = t_x;     __b[1] = t_y + h; __c[1] = t_x + w; __d[1] = t_y + h;
    __a[2] = t_x;     __b[2] = t_y;     __c[2] = t_x;     __d[2] = t_y + h;
    __a[3] = t_x + w; __b[3] = t_y;     __c[3] = t_x + w; __d[3] = t_y + h;

    int __e[4], __f[4], __g[4], __h[4];
    __e[0] = b.x + 0; __f[0] = b.y - s; __g[0] = b.x + s; __h[0] = b.y + 0;
    __e[1] = b.x + s; __f[1] = b.y + 0; __g[1] = b.x + 0; __h[1] = b.y + s;
    __e[2] = b.x + 0; __f[2] = b.y + s; __g[2] = b.x - s; __h[2] = b.y + 0;
    __e[3] = b.x - s; __f[3] = b.y + 0; __g[3] = b.x + 0; __h[3] = b.y - s;

    bool hit[4] = {false, false, false, false};

    for (int c = 0; c < 4; c++)
    {
        for (int d = 0; d < 4; d++)
        {
            if (line_line_intersection(__a[c], __b[c], __c[c], __d[c], __e[d], __f[d], __g[d], __h[d]) > 0)
            {
                hit[d] = true;
            }
        }
    }

    int left = false, right = false, up = false, down = false;

    if (hit[0] && hit[1])
    {
        right = true;
    }

    if (hit[1] && hit[2])
    {
        add_invader++;
        down = true;
    }


    if (hit[2] && hit[3])
    {
        left = true;
    }

    if (hit[0] && hit[3])
    {
        up = true;
    }

    if (hit[0] && !hit[1] && !hit[2] && !hit[3])
    {
        right = up = true;
    }
    if (!hit[0] && hit[1] && !hit[2] && !hit[3])
    {
        right = down = true;
    }
    if (!hit[0] && !hit[1] && hit[2] && !hit[3])
    {
        left = down = true;
    }
    if (!hit[0] && !hit[1] && !hit[2] && hit[3])
    {
        left = up = true;
    }

/*
    if (left) i.dx -= 1;
    if (right) i.dx += 1;
    if (up) i.dy -= 1;
    if (down) i.dy += 1;
*/
    if (left) i.dx = b.dx;
    if (right) i.dx = b.dx;
    if (up) i.dy = b.dy;
    if (down) i.dy = b.dy;

    if (left) b.dx = abs(b.dx);
    if (right) b.dx = -abs(b.dx);
    if (up) b.dy = abs(b.dy);
    if (down) b.dy = -abs(b.dy);

    textprintf_ex(screen, font, 0, 110, makecol(255,255,255), -1, "%d %d %d %d", up, down, left, right);
}

int main(int argc, char *argv[])
{
    allegro_init();
    install_keyboard();
    install_timer();
    install_mouse();

    LOCK_VARIABLE(logic_counter);
    LOCK_FUNCTION(logic_counter_handler);

    set_color_depth(32);
    set_gfx_mode(GFX_AUTODETECT_WINDOWED, GAME_WIDTH, GAME_HEIGHT, 0, 0);
    BITMAP *buffer = create_bitmap(GAME_WIDTH, GAME_HEIGHT);
    show_mouse(screen);

    SLING_SHOT sling;
    install_int(logic_counter_handler, 33);

    #include "fps/fps_setup.inc"


    BALL ba;

    INVADER inv((rand() % 600) - 300, (rand() % (SCREEN_H - 65)) + 65);
    invaders.add(inv);


    bool quitting = false;
    while (!quitting)
    {
        clear_bitmap(buffer);

        ba.x = ORIGIN(mouse_x);
        ba.y = mouse_y;

        while (logic_counter > 0)
        {
            sling.logic();
            balls.logic();
            invaders.logic();

            balls.prune();

            balls.items;

            add_invader = 0;
            for (std::list<INVADER>::iterator i = invaders.items.begin(); i != invaders.items.end(); i++)
            {
                for (std::list<BALL>::iterator j = balls.items.begin(); j != balls.items.end(); j++)
                {
                    colide(*i, *j);
                }
            }

            for (int p = 0; p < add_invader; p++)
            {
                invaders.add(INVADER((rand() % 600) - 300, (rand() % (SCREEN_H - 65)) + 65));
            }

            logic_counter--;
        }

        sling.render(buffer);
        balls.render(buffer);
        invaders.render(buffer);

        textprintf_ex(buffer, font, 0, 100, makecol(255,255,255), makecol(0, 0, 0), "Ball Count: %d", balls.count());

        #include "fps/fps_working.inc"

        textprintf_ex(buffer, font, 0, 0, makecol(255,255,255), makecol(0, 0, 0), "fps: %d", fps);
        blit(buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

        if (key[KEY_ESC])
            quitting = true;
    }


    destroy_bitmap(buffer);
    show_mouse(NULL);
    return 0;
}
END_OF_MAIN()
